summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authormischa <mischa@rx.high5.nl>2021-04-18 20:19:35 +0200
committermischa <mischa@rx.high5.nl>2021-04-18 20:19:35 +0200
commitd5a21bfba8ff7219b613da05f36f5bf6868f03ab (patch)
treeb60afb61880da2b73b7033b72fe856adcbc71176
parent666a49a49308aa27d5a39ebdc6c5368a1f5e38a1 (diff)
add helper shell scripts to more easily move VMs
-rwxr-xr-xmvvm.sh48
-rwxr-xr-xrelaunch.sh43
2 files changed, 91 insertions, 0 deletions
diff --git a/mvvm.sh b/mvvm.sh
new file mode 100755
index 0000000..5a36704
--- /dev/null
+++ b/mvvm.sh
@@ -0,0 +1,48 @@
+#!/bin/sh
+#
+# Copyright (c) 2019-2021 Mischa Peters <mischa @ openbsd.amsterdam>
+#
+# Permission to use, copy, modify, and distribute this software for any
+# purpose with or without fee is hereby granted, provided that the above
+# copyright notice and this permission notice appear in all copies.
+#
+# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+#
+if [[ -z $1 || -z $2 || -z $3 ]]; then
+ echo "Usage: $0 <source vm> <dest host> <dest vm>"
+ exit
+fi
+VM_CONF="$PWD/vms/${1}.txt"
+[ -f "$VM_CONF" ] && . "$VM_CONF"
+if [ ! -f "$VM_CONF" ]; then
+ echo "--> ${PWD}/vmm/${1}.txt doesn't exist"
+ exit
+fi
+if [ -n "$instance" ]; then
+ echo "instance name found: ${instance}"
+fi
+
+if [ -f "/var/vmm/${instance}.img" ]; then
+ echo -n "Size of img: "
+ ls -alh /var/vmm/${instance}.img | awk '{print $5}'
+ if [ ! -f "/var/vmm/${1}.qcow2" ]; then
+ echo "vmctl create -i /var/vmm/${instance}.img /var/vmm/${1}.qcow2"
+ vmctl create -i /var/vmm/${instance}.img /var/vmm/${1}.qcow2 && pushover.pl -m "vmctl create ${1} done"
+ fi
+fi
+if [ -f "/var/vmm/${instance}.qcow2" ]; then
+ cp /var/vmm/${instance}.qcow2 /var/vmm/${1}.qcow2
+fi
+
+if [ -f "/var/vmm/${1}.qcow2" ]; then
+ echo -n "Size of qcow2: "
+ ls -alh /var/vmm/${1}.qcow2 | awk '{print $5}'
+ echo "rsync -ve 'ssh -p 31415 -i ~mischa/.ssh/id_ed25519' --rsync-path='doas rsync' /var/vmm/${1}.qcow2 mischa@${2}.obsda.ms:/var/vmm/${3}.qcow2"
+ rsync -ve 'ssh -p 31415 -i ~mischa/.ssh/id_ed25519' --rsync-path='doas rsync' /var/vmm/${1}.qcow2 mischa@${2}.obsda.ms:/var/vmm/${3}.qcow2 && pushover.pl -m "rsync ${3} done"
+fi
diff --git a/relaunch.sh b/relaunch.sh
new file mode 100755
index 0000000..987e430
--- /dev/null
+++ b/relaunch.sh
@@ -0,0 +1,43 @@
+#!/bin/sh
+#
+# Copyright (c) 2019-2021 Mischa Peters <mischa @ openbsd.amsterdam>
+#
+# Permission to use, copy, modify, and distribute this software for any
+# purpose with or without fee is hereby granted, provided that the above
+# copyright notice and this permission notice appear in all copies.
+#
+# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+#
+CONF_FILE="${PWD}/_deploy.conf"
+if [[ -f "${CONF_FILE}" ]]; then
+ . "${CONF_FILE}"
+else
+ echo "unable to find _deploy.conf"
+ exit 1
+fi
+if [[ -z ${1} ]]; then
+ echo "usage: ${0##*/} vmXX"
+ exit 1
+fi
+if [[ ! -f "${VMS}/${1}.txt" ]]; then
+ echo "unable to find ${VMS}/${1}"
+ exit 1
+fi
+if [[ ! -f "${IMAGES}/${1}.qcow2" ]]; then
+ echo "unable to find ${IMAGES}/${1}.qcow2"
+ exit 1
+fi
+
+deploy.pl
+rcctl restart dhcpd
+vmctl reload
+vmctl start ${1}
+sleep 30
+echo "SUCCES! - deployed ${1}"
+notify.pl deployed ${1}